package com.zanxiang.manage.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.IService;
import com.zanxiang.manage.domain.dto.PromoSiteDTO;
import com.zanxiang.manage.domain.params.PromoSiteAddOrUpdateParam;
import com.zanxiang.manage.domain.params.PromoSiteListParam;
import com.zanxiang.manage.domain.vo.PromoSiteLinkageChoiceVO;
import com.zanxiang.manage.domain.vo.PromoSiteListVO;
import com.zanxiang.mybatis.entity.PromoSite;

import java.util.List;
import java.util.Map;

/**
 * @author : lingfeng
 * @time : 2022-11-18
 * @description : 推广版位
 */
public interface IPromoSiteService extends IService<PromoSite> {

    /**
     * 推广媒体位置版位信息
     *
     * @return {@link Map}<{@link Long}, {@link PromoSiteDTO}>
     */
    Map<Long, PromoSiteDTO> promoSiteMap();

    /**
     * 媒体版位位置联动选择列表
     *
     * @return {@link List}<{@link PromoSiteLinkageChoiceVO}>
     */
    List<PromoSiteLinkageChoiceVO> promoSiteLinkageChoiceList();

    /**
     * 查询游戏标签列表
     *
     * @param param : 游戏标签列表查询呢参数
     * @return {@link IPage}<{@link PromoSiteListVO}>
     */
    IPage<PromoSiteListVO> list(PromoSiteListParam param);

    /**
     * 根据主键更新状态
     *
     * @param id     : 主键id
     * @param status : 状态
     * @return {@link Boolean}
     */
    Boolean statusUpdate(Long id, Integer status);

    /**
     * 推广媒体新增或者更新
     *
     * @param param : 更新参数
     * @return {@link Boolean}
     */
    Boolean addOrUpdate(PromoSiteAddOrUpdateParam param);
}
