package com.zanxiang.manage.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.CollectionUtils;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.zanxiang.common.utils.bean.BeanUtils;
import com.zanxiang.manage.domain.dto.PayDeviceDTO;
import com.zanxiang.manage.domain.vo.PayDeviceChoiceVO;
import com.zanxiang.manage.service.IPayDeviceService;
import com.zanxiang.mybatis.entity.PayDevice;
import com.zanxiang.mybatis.mapper.PayDeviceMapper;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.util.Collections;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.stream.Collectors;

/**
 * @author : lingfeng
 * @time : 2023-02-09
 * @description : 支付方式
 */
@Service
@Slf4j
public class PayDeviceServiceImpl extends ServiceImpl<PayDeviceMapper, PayDevice> implements IPayDeviceService {

    @Override
    public List<PayDeviceChoiceVO> payDeviceChoiceList() {
        List<PayDevice> payDeviceList = super.list(new LambdaQueryWrapper<PayDevice>()
                .select(PayDevice::getId, PayDevice::getPayWayIds, PayDevice::getPayDeviceName)
        );
        return BeanUtils.copyList(payDeviceList, PayDeviceChoiceVO.class);
    }

    @Override
    public Map<Long, PayDeviceDTO> payDeviceMap() {
        //查询
        List<PayDevice> payDeviceList = super.list();
        if (CollectionUtils.isEmpty(payDeviceList)) {
            return Collections.emptyMap();
        }
        List<PayDeviceDTO> list = BeanUtils.copyList(payDeviceList, PayDeviceDTO.class);
        //构造返回
        return list.stream().collect(Collectors.toMap(PayDeviceDTO::getId, Function.identity()));
    }

    @Override
    public Map<Long, PayDeviceChoiceVO> payDeviceChoiceMap() {
        //查询
        List<PayDevice> payDeviceList = super.list();
        if (CollectionUtils.isEmpty(payDeviceList)) {
            return Collections.emptyMap();
        }
        List<PayDeviceChoiceVO> list = BeanUtils.copyList(payDeviceList, PayDeviceChoiceVO.class);
        //构造返回
        return list.stream().collect(Collectors.toMap(PayDeviceChoiceVO::getId, Function.identity()));
    }
}
